package com.cavaness.beer4all.catalog;

import java.util.List;
import org.apache.struts.action.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.cavaness.beer4all.service.Beer4AllService;
import com.cavaness.beer4all.framework.Beer4AllBaseDispatchAction;
import com.cavaness.beer4all.catalog.view.CatalogView;
import com.cavaness.beer4all.catalog.view.ItemView;
import com.cavaness.beer4all.util.Constants;

public class CatalogDispatchAction extends Beer4AllBaseDispatchAction{

  public ActionForward viewItem(ActionMapping mapping,
                                ActionForm form,
                                HttpServletRequest request,
                                HttpServletResponse response)
    throws Exception {

    String itemId = request.getParameter( Constants.ID_KEY );
    Beer4AllService service = getBeer4AllService();
    ItemView itemView = service.getItemById( itemId );

    // Make the item information available to the view
    request.setAttribute( Constants.ITEMVIEW_KEY, itemView );

    List featuredCatalogs = service.getFeaturedCatalogs();
    request.setAttribute( "featuredCatalogs", featuredCatalogs );

    return mapping.findForward(Constants.SUCCESS_KEY);
  }
}