package com.cavaness.beer4all.framework;

import org.apache.struts.action.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletContext;

import javax.servlet.http.HttpServlet;
import com.cavaness.beer4all.service.*;
import com.cavaness.beer4all.util.Constants;
import com.cavaness.beer4all.framework.UserContainer;
import com.cavaness.beer4all.service.ServiceStartupException;

abstract public class Beer4AllBaseAction extends Action {

  protected Beer4AllService getBeer4AllService() throws ServiceStartupException{
    ServletContext ctx = getServlet().getServletContext();

    ServiceFactory factory =
      (ServiceFactory)ctx.getAttribute(Constants.SERVICE_FACTORY_KEY);

    // We might want to check for the user's info and pass it along to
    // create a specific service. This might be used for profiling or
    // personalization as well.
    return (Beer4AllService)factory.createService();
  }

  protected UserContainer getUserContainer( HttpServletRequest request ){
    UserContainer container = (UserContainer)request.getSession().getAttribute( Constants.USER_CONTAINER_KEY );
    if (container == null){
      container = new UserContainer();
      container.setLocale( request.getLocale() );
      request.getSession().setAttribute( Constants.USER_CONTAINER_KEY, container );
    }
    return container;
  }
}