package com.cavaness.beer4all.framework;

import com.cavaness.beer4all.catalog.view.ItemView;

/**
 * This wraps the actual item class to help decouple the shopping cart from
 * the actual items it stores.
 */
public class ShoppingCartItem {
  public void setItem(ItemView newItem) {
    item = newItem;
    calculateExtendedPrice();
  }
  public void setExtendedPrice(double newPrice) {
    extendedPrice = newPrice;
  }
  public String getDescription() {
    return item.getDescription();
  }
  public Integer getId() {
    return item.getOid();
  }
  public String getName() {
    return item.getName();
  }
  public ShoppingCartItem(ItemView item, int qty) {
    this.item = item;
    this.quantity = qty;
    calculateExtendedPrice();
  }
  public int getQuantity() {
    return quantity;
  }
  public void setQuantity(int newQuantity) {
    quantity = newQuantity;
    calculateExtendedPrice();
  }
  public ItemView getItem() {
    return item;
  }
  public Double getUnitPrice() {
    return item.getPrice();
  }
  public double getExtendedPrice() {
    return extendedPrice;
  }
  private void calculateExtendedPrice() {
    if ( item.getPrice() != null ){
      extendedPrice = item.getPrice().doubleValue() * getQuantity();
    }
  }

  // Extended price is unit price * qty
  private double extendedPrice = 0.0;
  private ItemView item = null;

  // Default qty to 1
  private int quantity = 1;
}
