package com.cavaness.beer4all.security;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.*;
import org.apache.struts.util.MessageResources;
/**
 * Form bean for the user signon page.
 */
public class LoginForm extends ActionForm {

  private String password = null;
  private String username = null;

  public void setUsername(String username) {
    this.username = username;
  }

  public String getUsername() {
    return (this.username);
  }

  public String getPassword() {
    return (this.password);
  }

  public void setPassword(String password) {
    this.password = password;
  }

  /**
   * Validate the properties that have been set from this HTTP request,
   * and return an <code>ActionErrors</code> object that encapsulates any
   * validation errors that have been found.  If no errors are found, return
   * <code>null</code> or an <code>ActionErrors</code> object with no
   * recorded error messages.
   *
   * @param mapping The mapping used to select this instance
   * @param request The servlet request we are processing
   */
  public ActionErrors validate(ActionMapping mapping,
                               HttpServletRequest request) {
    ActionErrors errors = new ActionErrors();

    // Get access to the message resources for this application
    // There's not an easy way to access the resources from an ActionForm
    MessageResources resources =
      (MessageResources)request.getAttribute( Action.MESSAGES_KEY );

    if(getUsername() == null || getUsername().length() < 1) {
    String usernameLabel = resources.getMessage( "label.username" );

      errors.add( ActionErrors.GLOBAL_ERROR,
                  new ActionError("errors.required", usernameLabel ));
    }
    if(getPassword() == null || getPassword().length() < 1) {
    String passwordLabel = resources.getMessage( "label.password" );
      errors.add( ActionErrors.GLOBAL_ERROR,
                  new ActionError("errors.required", passwordLabel ));
    }
    return errors;
  }

  /**
   * Reset all properties to their default values.
   *
   * @param mapping The mapping used to select this instance
   * @param request The servlet request we are processing
   */
  public void reset(ActionMapping mapping,
                    HttpServletRequest request) {
    this.password = null;
    this.username = null;
  }
}