package com.cavaness.beer4all.security;

import java.util.Locale;
import javax.servlet.http.*;
import org.apache.struts.action.*;

import com.cavaness.beer4all.common.view.UserView;
import com.cavaness.beer4all.framework.UserContainer;
import com.cavaness.beer4all.framework.Beer4AllBaseAction;
import com.cavaness.beer4all.util.Constants;
import com.cavaness.beer4all.service.Beer4AllService;

/**
 * This action is called when a user checks out of the Storefront
 * application.
 */
public class LogoutAction extends Beer4AllBaseAction {
  public ActionForward execute( ActionMapping mapping,
                                ActionForm form,
                                HttpServletRequest request,
                                HttpServletResponse response )
    throws Exception {

    HttpSession session = request.getSession(false);
    // Make sure the user has a valid session
    if(session != null) {
      if(getUserContainer(request) != null) {
        // Login through the security service
        Beer4AllService serviceImpl = this.getBeer4AllService();
        serviceImpl.logout( getUserContainer(request).getUserView().getUsername() );
        getUserContainer(request).cleanUp();
      }
    }
    return mapping.findForward( Constants.SUCCESS_KEY );
  }
}
