package com.cavaness.beer4all.service;

import java.util.List;
import com.cavaness.beer4all.catalog.view.CatalogView;
import com.cavaness.beer4all.catalog.view.ItemView;
import com.cavaness.beer4all.common.view.UserView;
import com.cavaness.beer4all.common.exceptions.InvalidLoginException;
import com.cavaness.beer4all.common.exceptions.DatabaseException;

public interface Beer4AllService {
  public List getFeaturedItems() throws DatabaseException;
  public List getFeaturedCatalogs() throws DatabaseException;
  public ItemView getItemById( String itemId ) throws DatabaseException;
  public List getItemsInCatalog( String catalogId ) throws DatabaseException;
  public void logout(String email) throws DatabaseException;

  public UserView authenticate(String username, String password)
    throws DatabaseException, InvalidLoginException;
}