package com.cavaness.beer4all.service;

import org.apache.struts.action.*;
import org.apache.struts.config.*;
import com.cavaness.beer4all.util.Constants;
import javax.servlet.ServletException;

public class ServiceFactory implements PlugIn {
  private String serviceClassName = "com.cavaness.beer4all.service.Beer4AllServiceDebug";

  private ActionServlet servlet;

  public Beer4AllService createService() throws ServiceStartupException {
    Beer4AllService service = null;
    try{
      Class serviceClass = Class.forName( getServiceClassName() );
      service = (Beer4AllService)serviceClass.newInstance();
    }catch( Exception ex ){
      ex.printStackTrace();
      throw new ServiceStartupException( ex );
    }
    return service;
  }

  public String getServiceClassName(){
    return serviceClassName;
  }

  public void setServiceClassName( String className ){
    this.serviceClassName = className;
  }

  public void init(ActionServlet servlet, ApplicationConfig config)
    throws javax.servlet.ServletException{
      this.servlet = servlet;
      servlet.getServletContext().setAttribute( Constants.SERVICE_FACTORY_KEY, this );
    }

  public void destroy(){
    servlet.getServletContext().setAttribute( Constants.SERVICE_FACTORY_KEY, null );
    this.servlet = null;
  }
}